local MogIt,mog = ...;

local GetScreenWidth = GetScreenWidth;
local GetScreenHeight = GetScreenHeight;

mog.optscroll = CreateFrame("ScrollFrame","MogItFrameOptScroll",mog.frame,"UIPanelScrollFrameTemplate");
mog.optscroll:Hide();
mog.optscroll:SetPoint("TOPLEFT",mog.frame.Inset,"TOPLEFT",5,-4);
mog.optscroll:SetPoint("BOTTOMRIGHT",mog.frame.Inset,"BOTTOMRIGHT",-26,3);
mog.opt = CreateFrame("Frame","MogItFrameOptions",mog.grid);
mog.opt:SetSize(180,400);
mog.optscroll:SetScrollChild(mog.opt);
mog.optscroll:SetScript("OnShow",function(self)
	mog.opt.update();
end);

mog.opt.gen = mog.opt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.opt.gen:SetPoint("TOPLEFT",mog.opt,"TOPLEFT",5,-5);
mog.opt.gen:SetText(GENERAL);

mog.opt.mm = CreateFrame("CheckButton","MogItFrameMinimap",mog.opt,"UICheckButtonTemplate");
MogItFrameMinimapText:SetText("Hide Minimap Button");
mog.opt.mm:SetPoint("TOPLEFT",mog.opt.gen,"BOTTOMLEFT",0,0);
mog.opt.mm:SetScript("OnClick",function(self)
	if self:GetChecked() then
		mog.LDBI:Hide(MogIt);
	else
		mog.LDBI:Show(MogIt);
	end
end);

mog.opt.cat = mog.opt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.opt.cat:SetPoint("TOPLEFT",mog.opt.mm,"BOTTOMLEFT",0,-15);
mog.opt.cat:SetText("Catalogue");

mog.opt.cnaked = CreateFrame("CheckButton","MogItFrameCNaked",mog.opt,"UICheckButtonTemplate");
MogItFrameCNakedText:SetText("Naked models");
mog.opt.cnaked:SetPoint("TOPLEFT",mog.opt.cat,"BOTTOMLEFT",0,0);
mog.opt.cnaked:SetScript("OnClick",function(self)
	mog.settings.guiDress = not self:GetChecked();
	if mog.grid:IsShown() then
		mog.scroll:update();
	end
end);

function mog.opt.buttonUpdate(rows,columns)
	if rows then
		if mog.settings.rows == 1 then
			mog.opt.delrows:Hide();
		else
			mog.opt.delrows:Show();
		end
		local m = ((mog.settings.rows + 1)*(mog.settings.guiHeight + 5))-5+20+20;
		if m > GetScreenHeight() then
			mog.opt.addrows:Hide();
		else
			mog.opt.addrows:Show();
		end
	end
	if columns then
		if mog.settings.columns == 1 then
			mog.opt.delcolumns:Hide();
		else
			mog.opt.delcolumns:Show();
		end
		local m = ((mog.settings.columns + 1)*(mog.settings.guiWidth + 5))-5+20+43;
		if m > GetScreenWidth() then
			mog.opt.addcolumns:Hide();
		else
			mog.opt.addcolumns:Show();
		end
	end
end

mog.opt.addrows = CreateFrame("Button","MogItOptionsAddRows",mog.opt,"UIPanelButtonTemplate2");
mog.opt.addrows:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
mog.opt.addrows:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down");
mog.opt.addrows:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight","ADD");
mog.opt.addrows:SetSize(16,16);
mog.opt.addrows:SetPoint("TOPLEFT",mog.opt.cnaked,"BOTTOMLEFT",5,-3);
mog.opt.addrows:SetScript("OnClick",function(self)
	mog.settings.rows = mog.settings.rows + 1;
	mog.updateGUI();
	mog.scroll:update();
	mog.manip.mass(true);
	mog.opt.buttonUpdate(true);
end);

mog.opt.delrows = CreateFrame("Button","MogItOptionsDelRows",mog.opt,"UIPanelButtonTemplate2");
mog.opt.delrows:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
mog.opt.delrows:SetPushedTexture("Interface\\Buttons\\UI-MinusButton-Down");
mog.opt.delrows:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight","ADD");
mog.opt.delrows:SetSize(16,16);
mog.opt.delrows:SetPoint("TOPLEFT",mog.opt.addrows,"TOPRIGHT",0,0);
mog.opt.delrows:SetScript("OnClick",function(self)
	mog.settings.rows = mog.settings.rows - 1;
	mog.updateGUI();
	mog.scroll:update();
	mog.opt.buttonUpdate(true);
end);

mog.opt.rows = mog.opt:CreateFontString(nil,"ARTWORK","GameFontNormalSmall");
mog.opt.rows:SetPoint("TOPLEFT",mog.opt.delrows,"TOPRIGHT",3,-4);
mog.opt.rows:SetText("Rows");

mog.opt.addcolumns = CreateFrame("Button","MogItOptionsAddColumns",mog.opt,"UIPanelButtonTemplate2");
mog.opt.addcolumns:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up");
mog.opt.addcolumns:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down");
mog.opt.addcolumns:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight","ADD");
mog.opt.addcolumns:SetSize(16,16);
mog.opt.addcolumns:SetPoint("TOPLEFT",mog.opt.addrows,"BOTTOMLEFT",0,-3);
mog.opt.addcolumns:SetScript("OnClick",function(self)
	mog.settings.columns = mog.settings.columns + 1;
	mog.updateGUI();
	mog.scroll:update();
	mog.manip.mass(true);
	mog.opt.buttonUpdate(nil,true);
end);

mog.opt.delcolumns = CreateFrame("Button","MogItOptionsDelColumns",mog.opt,"UIPanelButtonTemplate2");
mog.opt.delcolumns:SetNormalTexture("Interface\\Buttons\\UI-MinusButton-Up");
mog.opt.delcolumns:SetPushedTexture("Interface\\Buttons\\UI-MinusButton-Down");
mog.opt.delcolumns:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight","ADD");
mog.opt.delcolumns:SetSize(16,16);
mog.opt.delcolumns:SetPoint("TOPLEFT",mog.opt.addcolumns,"TOPRIGHT",0,0);
mog.opt.delcolumns:SetScript("OnClick",function(self)
	mog.settings.columns = mog.settings.columns - 1;
	mog.updateGUI();
	mog.scroll:update();
	mog.opt.buttonUpdate(nil,true);
end);

mog.opt.columns = mog.opt:CreateFontString(nil,"ARTWORK","GameFontNormalSmall");
mog.opt.columns:SetPoint("TOPLEFT",mog.opt.delcolumns,"TOPRIGHT",3,-4);
mog.opt.columns:SetText("Columns");

mog.opt.itemurl = mog.opt:CreateFontString(nil,"ARTWORK","GameFontNormalSmall");
mog.opt.itemurl:SetPoint("TOPLEFT",mog.opt.addcolumns,"BOTTOMLEFT",0,-12);
mog.opt.itemurl:SetText("Item URL:");

mog.opt.url = CreateFrame("Frame","MogItFrameURLDropdown",mog.opt,"UIDropDownMenuTemplate");
mog.opt.url:SetPoint("LEFT",mog.opt.itemurl,"RIGHT",-8,-2);
UIDropDownMenu_SetWidth(mog.opt.url,88);
UIDropDownMenu_SetButtonWidth(mog.opt.url,103);
UIDropDownMenu_JustifyText(mog.opt.url,"LEFT");
function mog.opt.url:initialize()
	local info;
	for k,v in pairs(mog.urlList) do
		info = UIDropDownMenu_CreateInfo();
		info.text =	k;
		info.value = k;
		info.func = function(self)
			mog.settings.url = self.value;
			UIDropDownMenu_SetText(mog.opt.url,self.value);
		end
		info.notCheckable = true;
		info.icon = "Interface\\AddOns\\MogIt\\Images\\"..v.fav;
		UIDropDownMenu_AddButton(info);
	end
end

mog.opt.tt = mog.opt:CreateFontString(nil,"ARTWORK","GameFontHighlightSmall");
mog.opt.tt:SetPoint("TOPLEFT",mog.opt.itemurl,"BOTTOMLEFT",0,-22);
mog.opt.tt:SetText("Tooltip");

mog.opt.tooltip = CreateFrame("CheckButton","MogItFrameTooltip",mog.opt,"UICheckButtonTemplate");
MogItFrameTooltipText:SetText("Enable tooltip model");
mog.opt.tooltip:SetPoint("TOPLEFT",mog.opt.tt,"BOTTOMLEFT",0,0);
mog.opt.tooltip:SetScript("OnClick",function(self)
	mog.settings.tt = self:GetChecked();
end);

mog.opt.tnaked = CreateFrame("CheckButton","MogItFrameTNaked",mog.opt,"UICheckButtonTemplate");
MogItFrameTNakedText:SetText("Naked model");
mog.opt.tnaked:SetPoint("TOPLEFT",mog.opt.tooltip,"BOTTOMLEFT",0,0);
mog.opt.tnaked:SetScript("OnClick",function(self)
	mog.settings.ttDress = not self:GetChecked();
end);

mog.opt.mouse = CreateFrame("CheckButton","MogItFrameMouse",mog.opt,"UICheckButtonTemplate");
MogItFrameMouseText:SetText("Rotate with mouse wheel");
mog.opt.mouse:SetPoint("TOPLEFT",mog.opt.tnaked,"BOTTOMLEFT",0,0);
mog.opt.mouse:SetScript("OnClick",function(self)
	mog.settings.mouse = self:GetChecked();
end);

mog.opt.auto = CreateFrame("CheckButton","MogItFrameAuto",mog.opt,"UICheckButtonTemplate");
MogItFrameAutoText:SetText("Auto rotate");
mog.opt.auto:SetPoint("TOPLEFT",mog.opt.mouse,"BOTTOMLEFT",0,0);
mog.opt.auto:SetScript("OnClick",function(self)
	mog.settings.rotate = self:GetChecked();
	if mog.settings.rotate then
		mog.tooltip.rotate:Show();
	else
		mog.tooltip.rotate:Hide();
	end
end);

mog.opt.mog = CreateFrame("CheckButton","MogItFrameMog",mog.opt,"UICheckButtonTemplate");
MogItFrameMogText:SetText("Only uncommon/rare/epic");
mog.opt.mog:SetPoint("TOPLEFT",mog.opt.auto,"BOTTOMLEFT",0,0);
mog.opt.mog:SetScript("OnClick",function(self)
	mog.settings.mog = self:GetChecked();
end);

mog.opt.defaults = CreateFrame("Button",nil,mog.optscroll,"UIPanelButtonTemplate");
mog.opt.defaults:SetText(DEFAULTS);
mog.opt.defaults:SetSize(80,22);
mog.opt.defaults:SetPoint("TOPLEFT",mog.frame.Inset,"BOTTOMLEFT");
mog.opt.defaults:SetScript("OnClick",function(self,btn)
	mog.settings.minimap.hide = false;
	mog.settings.guiDress = false;
	mog.settings.tt = true;
	mog.settings.ttDress = false;
	mog.settings.mouse = true;
	mog.settings.rotate = true;
	mog.settings.mog = true;
	mog.settings.url = "Battle.net";
	
	mog.settings.guiWidth = 200;
	mog.settings.guiHeight = 200;
	mog.settings.rows = 2;
	mog.settings.columns = 3;
	
	mog.settings.posX = 0;
	mog.settings.posY = 0;
	mog.settings.posZ = 0;
	mog.settings.face = 0;
	
	mog.opt.update();
	mog.updateGUI();
	mog.scroll:update();
end);

function mog.opt.update()
	mog.opt.mm:SetChecked(mog.settings.minimap.hide);
	mog.opt.cnaked:SetChecked(not mog.settings.guiDress);
	mog.opt.tooltip:SetChecked(mog.settings.tt);
	mog.opt.tnaked:SetChecked(not mog.settings.ttDress);
	mog.opt.mouse:SetChecked(mog.settings.mouse);
	mog.opt.auto:SetChecked(mog.settings.rotate);
	mog.opt.mog:SetChecked(mog.settings.mog);
	UIDropDownMenu_SetText(mog.opt.url,mog.settings.url);
end

mog.opt.wowhead = mog.opt:CreateTexture(nil,"ARTWORK");
mog.opt.wowhead:SetSize(128,26);
mog.opt.wowhead:SetTexture("Interface\\AddOns\\MogIt\\Images\\Wowhead");
mog.opt.wowhead:SetTexCoord(0,158/256,0,1);
mog.opt.wowhead:SetPoint("BOTTOMRIGHT",mog.opt,"BOTTOMRIGHT",0,5);